const Main = imports.ui.main;
const Config = imports.misc.config;
const Me = imports.misc.extensionUtils.getCurrentExtension();
const { Gio } = imports.gi;
const Log = Me.imports.modules.log;
const Panel = Me.imports.modules.panel;
var Extension = class Extension {
    constructor() {
        this.gpuModeIndicatorInstance = null;
        this.gpuModeClient = null;
        this.systemMenu = null;
    }
    enable() {
        Gio.Resource.load(`${Me.path}/resources/org.gnome.Shell.Extensions.supergfxctl-gex.gresource`)._register();
        this.systemMenu = this.getSystemMenu();
        if (typeof this.systemMenu == 'undefined') {
            Log.raw('init', 'system menu is not defined');
            return false;
        }
        if (this.systemMenu._powerProfiles) {
            this.gpuModeIndicatorInstance = new Panel.gpuModeIndicator();
            this.systemMenu._indicators.remove_child(this.systemMenu._power);
            this.systemMenu._indicators.add_child(this.gpuModeIndicatorInstance);
            const menuItems = this.systemMenu.menu._getMenuItems();
            const powerMenuItemIndex = this.systemMenu._powerProfiles ? menuItems.indexOf(this.systemMenu._powerProfiles.menu) : -1;
            const menuIndex = powerMenuItemIndex > -1 ? powerMenuItemIndex + 1 : 3;
            this.systemMenu.menu.addMenuItem(this.gpuModeIndicatorInstance.menu, menuIndex);
            this.systemMenu._indicators.add_child(this.systemMenu._power);
        }
    }
    disable() {
        this.gpuModeIndicatorInstance.stop();
        this.gpuModeIndicatorInstance.menu.destroy();
        this.gpuModeIndicatorInstance.menu = null;
        this.gpuModeIndicatorInstance.destroy();
        this.gpuModeIndicatorInstance = null;
    }
    getSystemMenu() {
        if (parseInt(Config.PACKAGE_VERSION) < 43) {
            return Main.panel.statusArea.aggregateMenu;
        }
        else {
            return Main.panel.statusArea.quickSettings;
        }
    }
}
function init() {
    ext = new Extension();
    return ext;
}
//# sourceMappingURL=extension.js.map